#!/usr/bin/env python
import rospy
import tic_tac_toe_common as ttt

from std_msgs.msg import Int16
from socrates_workshop.srv import *

NODE_NAME = "node_difficulty"


PARAM_DIFFICULTY = "param_difficulty"
PARAM_DIFFICULTY_MIN = "param_difficulty_min"
PARAM_DIFFICULTY_MAX = "param_difficulty_max"

TOPIC_DIFFICULTY = "topic_difficulty"


def setCurrentDifficulty(value):

	min_diff = rospy.get_param(PARAM_DIFFICULTY_MIN)
	max_diff = rospy.get_param(PARAM_DIFFICULTY_MAX)
	
	value = max(min_diff, min(value, max_diff))	

	rospy.set_param(PARAM_DIFFICULTY, value)
	return value

def difficultyCallback(msg):
	value = msg.data

	value = setCurrentDifficulty(value)

	return IntIntResponse(value)
    
def init_this_node():

	rospy.init_node(NODE_NAME, anonymous=True)
	

	s = rospy.Service(ttt.concatTopicName(TOPIC_DIFFICULTY), IntInt, difficultyCallback)
	

	rospy.spin()

if __name__ == '__main__':
    init_this_node()
