#!/usr/bin/env python

from __future__ import print_function
# rospy for subscriber
import rospy
from sensor_msgs.msg import PointCloud
from geometry_msgs.msg import Point32
import cv2, cv_bridge
#ROS messages
from std_msgs.msg import String
from sensor_msgs.msg import Image
#ROS Image message to OpenCV2 image converter
from cv_bridge import CvBridge, CvBridgeError
import numpy as np
import sys
from matplotlib import pyplot as plt


class image_converter:

    def __init__(self):
        img_tpc = "camera/rgb/image_raw"
        img_tpc1 = "camera/depth/image_raw"
        self.image_pub = rospy.Publisher("img_pross2", Image, queue_size=5)
        self.image_sub = rospy.Subscriber(img_tpc, Image, self.img_callback)
        self.depth_sub = rospy.Subscriber(img_tpc1, Image, self.img_callback)
        self.bridge = CvBridge()

    # Convert ROS image to OpenCV2
    def img_callback(self,rgb_data, depth_data) :
        try:
            cv2_img = self.bridge.imgmsg_to_cv2(rgb_data, "bgr8")
            depth_img = self.bridge.imgmsg_to_cv2(depth_data, "passthrough")
            print (cv2_img)
            print (depth_img)
        except CvBridgeError as e:
            print(e)


def main(args):
    ic = image_converter()
    rospy.init_node('image_converter',anonymous=True)
    try:
        rospy.spin()
    except KeyboardInterrupt:
       print("Shutting down")
    cv2.destroyAllWindows()


if __name__ == '__main__':
    main(sys.argv)


#        imgproc_node_name = 'obj_recogkinect_server'
#        imgproc_topic_name = 'obj_recogkinect'
        #Topic where we provide it as service
#        self.image_service = rospy.Service(imgproc_node_name, imgproc_topic_name, self.handleimg_callback)
#        self.image_service = rospy.Service("img_pross1", Image)
        #Topic where we publish

        #Topic where we subscribe to Kinect
    #Define the image topic change it once you know the path
#    img_tpc = "camera/rgb/image_raw"
    #Spin until interrupted
#        img1 = cv2.imread("/home/maitreyee/pic1.png")
#        imgx = cv2.imread("/home/maitreyee/pic1.png")
#        orb = cv2.ORB_create()
#        kp = orb.detect(img1, None)
#        kp, des = orb.compute(img1, kp)
#        img2 = cv2.drawKeypoints(img1,kp,imgx,color=None, flags=2)
#        (rows,cols,channels) = img1.shape